source: MondoRescue/branches/2.2.5/mindi/rootfs/sbin/init @ 1741

Last change on this file since 1741 was 1741, checked in by Bruno Cornec, 12 years ago
  • Adds magic file to depllist in order to have file working + ldd which helps for debugging issues
  • tty modes correct to avoid sh error messages
  • Use ext3 normally and not ext2 instead
  • USB device should be corrected after reading (take 1st part)
  • Adds a mount_USB_here function derived from mount_CDROM_here
  • Property svn:keywords set to Id
File size: 18.1 KB
Line 
1#!/bin/sh
2#
3# $Id: init 1741 2007-10-30 10:44:02Z bruno $
4#
5# init script launched during the restore process
6#------------------------------------------------------------
7
8
9CaughtSoftReset() {
10    trap SIGTERM
11    reboot
12}
13
14
15ConfigureLoggingDaemons() {
16    echo -en "Running klogd..."
17    klogd -c 2 > /dev/null 2> /dev/null
18    echo -en "Done.\nRunning syslogd..."
19    syslogd > /dev/null 2> /dev/null
20    echo "Done."
21    LogIt "klogd and syslogd have been started."
22}
23
24
25
26CopyBootDevEntry() {
27    local outfile devfile
28    devfile=/dev/boot_device
29    outfile=`cat /BOOTLOADER.DEVICE 2> /dev/null`
30    [ ! "$outfile" ] && return 0
31    echo -en "Copying boot device to $outfile..."
32    if [ -e "$outfile" ] ; then
33        echo "OK."
34        return 0
35    fi
36    mkdir -p $outfile
37    rmdir $outfile
38    cp -pRdf $devfile $outfile
39    if [ "$?" -ne "0" ] ; then
40        echo "Failed."
41        return 1
42    else
43        echo "OK."
44        return 0
45    fi
46}
47
48
49
50Die() {
51    LogIt "Fatal error! $1" 1
52    exit 1
53}
54
55
56
57ExtractDevTarballs() {
58    cd /
59    for fname in ataraid.tgz ida.tgz i2o.tgz rd.tgz raw.tgz cciss.tgz nst.tgz dm.tgz vc.tgz ; do
60        if [ ! -e "/$fname" ] ; then
61            LogIt "/$fname not found; cannot extract to /." 1
62        else
63            echo -en "\rExtracting /$fname...     "
64            tar -zxf /$fname || LogIt "Error occurred while extracting /$fname"
65        fi
66    done
67    echo -en "\r"
68    LogIt "Extracted additional /dev entries OK.     " 1
69}
70
71
72
73LaunchTerminals() {
74    openvt 2 /bin/sh
75    openvt 3 /bin/sh
76    openvt 4 /bin/sh
77    openvt 5 /bin/sh
78    openvt 6 /bin/sh
79    openvt 7 /bin/sh /sbin/wait-for-petris
80}
81
82
83LoadKeymap() {
84    local fname
85    fname=`cat /tmp/KEYMAP-LIVES-HERE 2> /dev/null`
86    [ "$fname" = "" ] && return
87    if which loadkeys > /dev/null 2> /dev/null ; then
88        loadkeys $fname
89# loadkmap != loadkeys
90#    elif which loadkmap > /dev/null 2> /dev/null ; then
91#        loadkmap < $fname
92    else
93        LogIt "Using default keyboard map." 1
94    fi
95}
96
97
98UntarTapeStuff() {
99    local old_pwd res
100    old_pwd=`pwd`
101    cd $GROOVY
102    [ "$1" != "" ] && tapedev=$1
103    [ ! "$tapedev" ] && tapedev=`grep media-dev /tmp/mondo-restore.cfg | tr -s ' ' ' ' | cut -d' ' -f2`
104#    tar -zxf $tapedev
105    dd if=$tapedev bs=32k count=1024 | tar -zx
106    res=$?
107    if [ "$res" -eq "0" ] ; then
108        grep -v media-dev /tmp/mondo-restore.cfg > /tmp/mr.cfg
109        echo "media-dev $tapedev" >> /tmp/mr.cfg
110        cp -f /tmp/mr.cfg /tmp/mondo-restore.cfg
111    fi
112    cd $old_pwd
113    return $res
114}
115
116HandleTape() {
117    local res tapedev
118    tapedev="" ; # will be set by UntarTapeStuff()
119    cd $GROOVY
120    UntarTapeStuff $tapedev || UntarTapeStuff /dev/st0 || UntarTapeStuff /dev/osst0 || UntarTapeStuff /dev/ht0
121    res=$?
122    while [ "$res" -ne "0" ] ; do
123        LogIt "$tapedev failed to act as extended data disk for booting." 1
124        LogIt "Please specify an alternate tape device," 1
125        LogIt "or hit <Enter> to boot from CD/floppies." 1
126        echo -en "---> "
127        read tapedev
128        if [ "$tapedev" ] ; then
129            LogIt "User specified $tapedev instead"
130            UntarTapeStuff $tapedev
131            res=$?
132        else
133            LogIt "User opted not to specify an alternate tapedev"
134            res=1
135        break
136        fi
137    done
138
139    if [ "$res" -ne "0" ] ; then
140        cd /
141        LogIt "Failed to use tape as extended datadisk. Reverting to floppies." 1
142        HandleCDROMorFloppies
143        res=$?
144    else
145#       clear
146        LogIt "Using tape as extended datadisk. Good." 3
147        echo "Using tape as extd ddisk." > /tmp/TAPEDEV-HAS-DATA-DISKS
148        res=0
149        CD_MOUNTED_OK=yes
150    fi
151    return $res
152}
153
154
155
156HandleCDROMorFloppies() {
157    find-and-mount-cdrom
158    res=$?
159    if [ "$res" -ne "0" ] ; then
160        LogIt "First call to find-and-mount-cdrom failed." 1
161        LogIt "Sleeping for 3 seconds and trying again." 1
162        sleep 3
163        find-and-mount-cdrom
164        res=$?
165    fi
166    if [ "$res" -eq "0" ] ; then
167        LogIt "OK, I am running on a CD-ROM. Good." 3
168        CD_MOUNTED_OK=yes
169    elif [ "$res" -eq "1" ] ; then
170        LogIt "OK, I am running on floppies. Good." 3
171        CD_MOUNTED_OK=""
172    else
173        LogIt "OK, I am falling back to floppy mode." 3
174        LogIt "That means you'll have to copy the data disk images from" 3
175        LogIt "the CD/hard disk/whatever to physical 1.44MB disks and" 3
176        LogIt "insert them, one after the other. Please see the manual." 3
177        LogIt "The images are in /images on the CD, or /root/images/mindi" 3
178        LogIt "on your hard disk. Your archives are probably fine but" 3
179        LogIt "your tape streamer and/or CD-ROM drive are eccentric. :-)" 3
180        CD_MOUNTED_OK=""
181    fi
182    return 0
183}
184
185
186HowMuchFreeSpaceOnRamdisk() {
187   df -m -P | grep /dev/ram | head -n1 | tr -s '\t' ' ' | cut -d' ' -f4
188}
189
190
191
192InsertEssentialModules() {
193#   Load the VIA IDE module first thing if it exists (requires ide-core).
194#   This is to ensure that DMA is working for VIA chipsets with 2.6 kernels.
195    for module in /ide-core.ko /via82cxxx.ko; do
196        [ -f "$module" ] && MyInsmod $module > /dev/null 2> /dev/null
197    done
198#   Then load the remaining modules in normal (i.e. arbitrary) order.
199    for j in 1 2 3 4 5 ; do
200        for i in `ls /*.*o* 2> /dev/null` ; do
201            [ -f "$i" ] && MyInsmod $i > /dev/null 2> /dev/null
202        done
203    done
204}
205
206
207
208PauseForRaids() {
209    if [ "`dmesg | grep -i "RAID Controller"`" != "" ] || [ "`dmesg | grep -i "Vendor: 3ware"`" != "" ] ; then
210        LogIt "RAID controller(s) detected. Pausing 10 seconds to let them warm up." 1
211        echo -en "Pausing..."
212        for i in 1 2 3 4 5 6 7 8 9 10 ; do
213            sleep 1
214            echo -en "$(($i*10))%..."
215        done
216        echo "Done."
217    fi
218}
219
220
221# 06/13/2002 --- DuckX's & Hugo's new routine
222# 10/11/2003 --- added a simple devfsd.conf file
223# 01/24/2005 --- cater for arbitrary locations of devfsd.conf by using the
224#                config file path compiled into devfsd
225RunDevfsd() {
226    loc=`which devfsd 2> /dev/null`
227    if [ "$loc" != "" ] ; then
228    LogIt "Devfs found. Testing kernel support..."
229    if [ ! -e "/dev/.devfsd" ] ; then
230        mount -t devfs devfs /dev 2>> $LOGFILE
231            if [ "$?" -ne "0" ] ; then
232        LogIt "Error while trying to mount devfs"
233        else
234        LogIt "Devfs mounted OK"
235        fi
236    fi
237    #check if the kernel supports devfs
238    if [ -e "/dev/.devfsd" ] ; then
239        [ -d "/proc/1" ] || mount -n /proc
240        LogIt "Kernel support found. Creating config file and starting devfsd"
241        conffile=`strings $loc | grep -E "devfsd.conf$"`
242        [ "$conffile" ] || conffile="/etc/devfsd.conf"
243        confpath=`echo $conffile | sed "s/\/devfsd\.conf$//"`
244        [ -d "$confpath" ] || mkdir -p $confpath
245        echo -en "REGISTER .* MKOLDCOMPAT\nUNREGISTER .* RMOLDCOMPAT\n" > $conffile
246        devfsd /dev &
247        sleep 5
248    else
249        LogIt "No devfs kernel support."
250    fi
251    fi
252}
253
254# Taken from udev management in Mandriva 2008.0. Kudos guys
255make_extra_nodes () {
256    # there are a few things that sysfs does not export for us.
257    # these things are listed in /etc/udev/links.conf
258    grep '^[^#]' /etc/udev-links.conf | \
259    while read type name arg1; do
260        [ "$type" -a "$name" -a ! -e "/dev/$name" -a ! -L "/dev/$name" ] ||continue
261        case "$type" in
262            L) ln -s $arg1 /dev/$name ;;
263            D) mkdir -p /dev/$name ;;
264            M) mknod /dev/$name $arg1 && chmod 600 /dev/$name;;
265            *) echo "udev-links.conf: unparseable line (%s %s %s)\n" "$type" "$name" "$arg1" ;;
266        esac
267    done
268}
269
270
271RunUdevd() {
272    # Inspiration from Mandriva 2008.0 startup script
273    echo "Preparing udev environment..."
274    mv /dev /dev.static
275    mkdir /dev
276    mount -n -o size=5M,mode=0755 -t tmpfs none /dev
277    make_extra_nodes
278    mount -n -t devpts -o mode=620 none /dev/pts
279    mount -n -t tmpfs  none /dev/shm
280    PKLVL=`cut -f1 /proc/sys/kernel/printk`
281    echo 0 > /proc/sys/kernel/printk
282    /sbin/udevd --daemon
283    echo $PKLVL > /proc/sys/kernel/printk
284    # Avoids shell error messages
285    chmod 644 /dev/tty*
286}
287
288
289
290
291#RunDevfsd() {
292#    loc=`which devfsd 2> /dev/null`
293#    if [ "$loc" != "" ] ; then
294#        LogIt "Starting devfsd"
295#        devfsd /dev &
296#        sleep 5
297#    fi
298#}
299
300
301
302SpaceTests() {
303    [ -e "/tmp/filelist.full" ] && cp /tmp/filelist.full /tmp/FLF
304    if [ "`HowMuchFreeSpaceOnRamdisk`" -le "3" ] ; then
305        LogIt "Ramdisk is a bit smaller than I would like." 1
306        LogIt "Please re-run Mondo/Mindi but edit /usr/local/mindi first" 1
307        LogIt "and set EXTRA_SPACE to something high, e.g. 8000" 1
308        Die "Aborting. Please reboot."
309    fi
310    rm -f /tmp/FLF
311}
312
313
314
315StartLvms() {
316    if [ -e "/tmp/i-want-my-lvm" ] ; then
317        LogIt "Scanning LVM's..." 1
318        if which lvm ; then
319            MyInsmod dm-mod
320            MyInsmod dm_mod
321            lvm vgscan --mknodes
322        else
323            vgscan
324        fi
325        grep -E "^#.*vgchange" /tmp/i-want-my-lvm | sed "s/^#[ ]*//" > /tmp/start-lvm
326        chmod +x /tmp/start-lvm
327        echo -en "Starting LVM's..."
328        /tmp/start-lvm &
329        for i in 1 2 3 4 5 ; do
330            echo -en "."
331            sleep 1
332        done
333        echo "Done."
334    fi
335# If necessary, cannibalize 'analyze-my-lvm'; copy some of its code here,
336# pipe vgscan's output, strip it, run 'vgchange' on its output, etc.etc.
337    LogIt "LVM's have been started."
338}
339
340
341StartRaids() {
342    local raid_devices i
343
344    raid_devices=`grep /dev/md /tmp/mountlist.txt | cut -d' ' -f1`
345    if which raidstart > /dev/null 2> /dev/null ; then
346        for i in $raid_devices ; do
347            if grep `basename $i` /proc/mdstat > /dev/null 2> /dev/null ; then
348                LogIt "$i is started already; no need to run 'raidstart $i'" 1
349            else
350                LogIt "Running 'raidstart $i'" 1
351                raidstart $i
352            fi
353        done
354    elif which mdrun > /dev/null 2> /dev/null ; then
355        LogIt "Running 'mdrun'" 1
356        mdrun
357    elif which mdadm > /dev/null 2> /dev/null ; then
358        LogIt "Running 'mdadm'" 1
359        for i in $raid_devices ; do
360            if grep `basename $i` /proc/mdstat > /dev/null 2> /dev/null ; then
361                LogIt "$i is started already; no need to run 'mdadm $i'" 1
362            else
363                if [ -f /etc/mdadm.conf ] ; then
364                    LogIt "Running 'mdadm $i' with user supplied /etc/mdadm.conf" 1
365                    mdadm -A $i -c /etc/mdadm.conf
366                elif [ -f /etc/mdadm/mdadm.conf ] ; then
367                    LogIt "Running 'mdadm $i' with user supplied /etc/mdadm/mdadm.conf" 1
368                    mdadm -A $i -c /etc/mdadm/mdadm.conf
369                else
370                    LogIt "Running 'mdadm $i'" 1
371                    mdadm -Ac partitions -m dev $i
372                fi
373            fi
374        done
375    else
376        LogIt "Warning: Neither 'raidstart' nor 'mdrun''found. RAID devices may not have started." 1
377    fi
378
379}
380
381
382TryAgainToFindCD() {
383    local res
384    mount | grep /mnt/cdrom && return 0
385    [ "`grep "backup_media_type" /tmp/mondo-restore.cfg | grep "cdstream"`" ] && return
386    LogIt "Trying to mount CD-ROM a 2nd time..."
387    find-and-mount-cdrom --second-try
388    res=$?
389    if [ "$res" -eq "0" ] ; then
390        CD_MOUNTED_OK=yes
391        LogIt "CD-ROM drive mounted successfully." 1
392    else
393        LogIt "I still cannot find or mount the CD-ROM drive, by the way."
394    fi
395}
396
397
398
399UseTmpfs()
400{
401    local mount_cmd
402    echo -en "Mounting /tmp/tmpfs..."
403    mkdir -p /tmp/tmpfs
404# For technical reasons, some sets are as large as 16MB.
405# I am allowing 32MB because selective restore occupies a lot of space.
406    for size in 64m 48m 40m 32m ; do
407        mount_cmd="mount /dev/shm -t tmpfs -o size=$size" ; # was 34m until 04/2003
408        LogIt "Trying '$mount_cmd'"
409    $mount_cmd /tmp/tmpfs 2>> $LOGFILE
410    res=$?
411    [ "$res" -eq "0" ] && break
412    done
413    if [ "$res" -ne "0" ] ; then
414        LogIt "Failed. I could not run '$mount_cmd /tmp/tmpfs'. Your kernel is BROKEN or you do not have enough RAM." 1
415        umount /tmp/tmpfs > /dev/null 2> /dev/null
416    rmdir /tmp/tmpfs
417        ln -sf /mnt/RESTORING/tmp /tmp/tmpfs; # used by mondo-restore
418    LogIt "Failed to mount /tmp/tmpfs; using ugly softlink instead"
419    else
420        LogIt "Great. Pivot succeeded w/ size=$size" 1
421        echo -en "Pivoting /tmp..."
422        umount /tmp/tmpfs
423        mkdir -p /tmp.old
424        mv -f /tmp/* /tmp.old/
425        $mount_cmd /tmp
426        mv /tmp.old/* /tmp/
427        rmdir /tmp.old
428        mkdir -p /tmp/tmpfs
429        mkdir -p $GROOVY
430    echo "Done."
431    LogIt "Successfully mounted dynamic /tmp ramdisk"
432#   mkdir -p /tmp/tmpfs/var
433#        mv -f /var/log /tmp/tmpfs/var/log
434#        ln -sf /tmp/tmpfs/var/log /var/log
435    fi
436}
437
438
439WelcomeMessage()
440{
441    echo "********************************************************************"
442    echo "MINDI-LINUX by Mondo Dev Team - web site: http://www.mondorescue.org"
443    echo "Boot disk based on AlfaLinux & Trinux. BusyBox by Erik Andersen."
444which petris > /dev/null 2> /dev/null && echo "Petris was written by Peter Seidler <p.seidler@mail1.stofanet.dk>."
445    echo "Executables and source code are covered by the GNU GPL. No warranty."
446    echo "running on $ARCH"
447    echo "********************************************************************"
448}
449
450
451EnableCcissIfAppropriate() {
452    local i fname
453    for i in 0 1 2 3 ; do
454        fname="/proc/driver/cciss/cciss$i"
455        if [ -e "$fname" ] ; then
456            LogIt "Engaging $fname"
457            echo "engage scsi" > $fname
458            LogIt "...result=$?"
459        fi
460    done
461}
462
463
464ExtractDataDisksAndLoadModules() {
465    echo "Installing additional tools ..."
466    install-additional-tools
467    echo "Inserting modules ..."
468    # Keep the kernel silent again
469    PKLVL=`cut -f1 /proc/sys/kernel/printk`
470    echo 0 > /proc/sys/kernel/printk
471    insert-all-my-modules >> $LOGFILE 2>> $LOGFILE
472    echo $PKLVL > /proc/sys/kernel/printk
473}
474
475# ------------------------ main -----------------------
476
477MINDI_VER=PBVER
478MINDI_REV=PBREV
479trap CaughtSoftReset SIGTERM
480LOGFILE=/var/log/mondorestore.log
481PATH=/bin:/usr/bin:/sbin:/usr/sbin:/usr/local/bin:/usr/local/sbin:/mondo:/usr/games
482GROOVY=/tmp/groovy-stuff
483USER=root
484export PATH GROOVY USER LOGFILE
485
486echo "Welcome to init (from mindi ${MINDI_VER}-r${MINDI_REV})"
487
488mount -o remount rw /
489[ ! "$GROOVY" ] && Die "I'm not groovy!"
490for i in $GROOVY /mnt/floppy /mnt/cdrom /mnt/isodir /var/local/petris /tmp/isodir; do
491    mkdir -p $i
492done
493#/bin/update
494mount /proc/ /proc -v -t proc
495mkdir /sys 2> /dev/null
496mount /sys/ /sys -v -t sysfs 2>> $LOGFILE
497rm -f /foozero
498
499if [ -f /proc/sys/kernel/exec-shield ]; then
500    echo 0 > /proc/sys/kernel/exec-shield 2>> /dev/null
501fi
502
503if [ -f /proc/modules ]; then
504    echo "/sbin/modprobe" > /proc/sys/kernel/modprobe
505fi
506
507if [ -e "/tmp/USE-UDEV" ] ; then
508    RunUdevd
509else
510    ExtractDevTarballs
511fi
512LaunchTerminals
513
514# Keeping kernel silent  for module insertion
515PKLVL=`cut -f1 /proc/sys/kernel/printk`
516echo 0 > /proc/sys/kernel/printk
517InsertEssentialModules
518echo $PKLVL > /proc/sys/kernel/printk
519
520EnableCcissIfAppropriate
521#-------------------------------
522#WHOLIVESINAPINEAPPLEUNDERTHESEA#;# --- don't touch this :)
523#-------------------------------
524UseTmpfs
525if [ ! -e "/tmp/mondo-restore.cfg" ] ; then
526    LogIt "Warning - /tmp/mondo-restore.cfg not found"
527fi
528
529if [ "`grep -i 'tape ' /tmp/mondo-restore.cfg`" ] || [ "`grep -i udev /tmp/mondo-restore.cfg`" ]; then
530    HandleTape
531    ExtractDataDisksAndLoadModules
532elif [ "`grep -i pxe /proc/cmdline`" ]; then
533    # We need to get here exported variables from start-nfs
534    . /sbin/start-nfs
535
536    # Simulate a local CD
537    echo "/mnt/cdrom" > /tmp/CDROM-LIVES-HERE
538    CD_MOUNTED_OK=yes
539    ExtractDataDisksAndLoadModules
540elif [ "`grep -i usb= /proc/cmdline`" ] || [ "`grep -i usb /tmp/mondo-restore.cfg | grep media-type`" ]; then
541    # We need to get here exported variables from start-nfs
542    . /sbin/start-usb
543
544    # Simulate a local CD
545    echo "/mnt/cdrom" > /tmp/CDROM-LIVES-HERE
546    CD_MOUNTED_OK=yes
547    ExtractDataDisksAndLoadModules
548else
549    HandleCDROMorFloppies
550    ExtractDataDisksAndLoadModules
551    # We need to get here exported variables from start-nfs
552    . /sbin/start-nfs
553fi
554res=$?
555ConfigureLoggingDaemons
556if [ -e "/tmp/USE-DEVFS" ] ; then
557    umount /mnt/cdrom 2> /dev/null
558    mv /dev/cdrom /cdrom.lnk 2> /dev/null
559    CD_MOUNTED_OK=""
560    RunDevfsd
561fi
562echo "Starting potential Raid/LVMs ..."
563PauseForRaids
564StartRaids
565StartLvms
566CopyBootDevEntry
567LoadKeymap
568mkdir -p /tmp/tmpfs
569sleep 2
570#clear
571if [ -e "/dev/md0" ] && [ ! -e "/dev/md/0" ] && [ "`grep /dev/md/ /tmp/mountlist.txt`" != "" ] ; then
572    LogIt "Creating /dev/md/* softlinks just in case." 1
573    mkdir -p /dev/md
574    cp -af /dev/md0 /dev/md/0 2> /dev/null
575    cp -af /dev/md1 /dev/md/1 2> /dev/null
576    cp -af /dev/md2 /dev/md/2 2> /dev/null
577fi
578export ARCH=`uname -m`
579WelcomeMessage
580# SpaceTests; # Mandrake Linux 8.1 doesn't like this
581[ -e "/tmp/mountlist.txt" ] && cp -f /tmp/mountlist.txt /tmp/mountlist.original
582
583if ! [ "`grep -i "pxe" /proc/cmdline`" ] ; then
584    res="`cat /mnt/cdrom/archives/THIS-CD-NUMBER 2> /dev/null`"
585    [ "$res" != "1" ] && [ "$res" != "" ] && Die "This is CD #$res in the series. Please insert CD #1."
586    [ -e "/cdrom.lnk" ] && mv -f /cdrom.lnk /dev/cdrom && mount /dev/cdrom /mnt/cdrom && CD_MOUNTED_OK=yes
587    [ "$CD_MOUNTED_OK" != "yes" ] && TryAgainToFindCD
588    #mount | grep cdrom > /dev/null 2> /dev/null || mount /dev/cdrom /mnt/cdrom >> $LOGFILE 2>> $LOGFILE
589fi
590hack-cfg-if-necessary || LogIt "Cannot find hack-cfg-if-necessary"
591openvt 8 /usr/bin/tail -f $LOGFILE
592
593# Log some useful info
594LogIt "init (from mindi v$MINDI_VER-r${MINDI_REV}"
595LogIt "/proc/cmdline is:"
596cat /proc/cmdline  >> $LOGFILE
597LogIt "df result:"
598LogIt "----------"
599df >> $LOGFILE
600LogIt "-------------"
601LogIt "mount result:"
602LogIt "-------------"
603mount >> $LOGFILE
604LogIt "-------------"
605LogIt "lsmod result:"
606LogIt "-------------"
607lsmod >> $LOGFILE
608LogIt "-------------"
609LogIt "dmesg result:"
610LogIt "-------------"
611dmesg >> $LOGFILE
612
613#-------------------------------
614#ABSORBENTANDYELLOWANDPOROUSISHE#;# --- don't touch this either :)
615#-------------------------------
616
617#ctrlaltdel soft
618for path in /usr.bin /usr/bin ; do
619    fname=$path/nano
620    [ -e "$fname" ] && ln -sf $fname /usr/bin/pico
621done
622res=`which nano 2> /dev/null`
623[ "$res" ] && ln -sf /usr/bin/
624for i in null stdout stdin stderr ; do
625    cp -af /dev/$i /tmp
626done
627if grep "backup-media-type" /tmp/mondo-restore.cfg > /dev/null 2> /dev/null ; then
628    LogIt "backup-media-type is specified in config file - great."
629    LogIt "Calling post-init $mountlist"
630    post-init
631else
632    LogIt "backup-media-type is not specified in config file."
633    LogIt "I think this CD/floppy has no archives on it."
634fi
635if grep "RESTORE" /proc/cmdline > /dev/null 2> /dev/null ; then
636    echo "Rebooting in 10 seconds automatically as per reboot order"
637    echo -en "Press ^C to interrupt if you have to ..."
638    for i in 1 2 3 4 5 6 7 8 9 10 ; do
639        sleep 1
640        echo -en "."
641    done
642    echo "Boom."
643    sleep 1
644else
645    echo -en "Type 'exit' to reboot the PC\n"
646    umount /mnt/cdrom 2> /dev/null
647    mount / -o rw,remount > /dev/null 2> /dev/null
648    LogIt "Launching Shell"
649    sh
650fi
651CaughtSoftReset
652# reboot
Note: See TracBrowser for help on using the repository browser.